		org	100h         ; com

l0:		in	al,60h       ;
		test	al,128       ; 1-st key - skip
		jz	l0           ;

		mov	ax,3509h             ; save current 
		int	21h                  ; keyboard handler
		mov	[old_kbd_int],bx     ;
		mov	[old_kbd_int + 2],es ;

		mov	dx,kbd_int           ;  set new
		mov	ax,2509h     	     ;  keyboard 
		int	21h          	     ;        handler
;-------------------------------------------------------------------------------

		mov	dx,msg1              ;
		mov	ah,9                 ;  stroka - output
		int	21h                  ;

l1:
		mov	al,[pos]             ;
		add	al,48                ;  the number of code-key
		mov	[msg3],al            ;
		mov	ah,9                 ;
		mov	dx,msg3              ;
		int	21h                  

		cmp	byte [mode],0
		jz	l1

		mov	dx,msg2
		mov	ah,9
		int	21h

		mov	ax,13h
		int	10h

star_cycle:
		mov	ax,0A000h
		mov	es,ax
		call	retrace
		mov	cx,200
		xor	si,si
move:		xor	ax,ax
		mov	di,cx
		add	di,data
		mov	al,[di]
		inc	al	
		
		mov	di,cx
		shl	di,1
		add	di,data + 200
		mov	bx,[di]

		push	bx
		shr	bx,4
		mov	byte [es:si+bx],0
		pop	bx

		add	bx,ax
		cmp	byte [firstly],1
		jz	regenerate
		
		cmp	bx,319 * 16
		jnb	regenerate
		jmp	display
regenerate:
		call	random
		mov	al,[seed]
		and	al,15
		push	di
		mov	di,cx
		add	di,data
		mov	[di],al
		pop	di

		mov	bx,0

display:	
		add	al,15
		push	bx
		shr	bx,4
		mov	byte [es:si+bx],al
		pop	bx

		mov	[di],bx

		add	si,320

		loop	move

		mov	byte [firstly],0

		cld
		push	cs
		pop	ds
		push	cs
		pop	es
l2:             mov	si,password
		mov	di,try
		mov	cx,[len]
l3:		lodsb
		scasb
		jnz	star_cycle
		loop	l3

		mov	ax,3h
		int	10h

		mov	dx,[old_kbd_int]
		mov	ds,[old_kbd_int + 2]
		mov	ax,2509h
		int	21h

		int	20h

kbd_int:	push	ax
		push	bx
		push	si
		push	di
		push	ds
		push	es

		in	al,60h			; fetching the key
		mov	ah,al

		mov	al,20h			; confirming interrupt
		out	20h,al

		test	ah,128
		jnz	int_exit

		cmp	byte [mode],2
		jz	int_exit

		push	cs
		pop	ds
		push	cs
		pop	es

		cmp	byte [mode],0
		jz	creating
entering:	cld
		mov	si,try + 1
		mov	di,try
		mov	cx,[len]
		dec	cx
		rep	movsb
		mov	[di],ah
		jmp	int_exit
;--------------------------------------------------------------------------
creating:	mov	bx,password
		add	bx,[pos]
		mov	[bx],ah
		inc	word [pos]
		mov	ax,[len]
		cmp	[pos],ax
		jne	int_exit
		mov	byte [mode],1
int_exit:	pop	es
		pop	ds
		pop	di
		pop	si
		pop	bx
		pop	ax
		iret

retrace:	push	ax
		push	dx
		mov	dx,3DAh
r1:		in	al,dx
		and	al,8
		jnz	r1
r2:		in	al,dx
		and	al,8
		jz	r2
		pop	dx
		pop	ax
		ret

random:		push	ax
		push	bx
		push	dx
		mov	ax,[seed]
		add	ax,7
		mov	bx,197
		mul	bx
		add	ax,180
		mov	[seed],ax
		pop	dx
		pop	bx
		pop	ax
		ret

msg1		db	'Enter password (5 keys): $'
msg2		db	10,13,'Password accepted',10,13,'$'
msg3		db	'0',8,'$'

old_kbd_int	dd	0

mode		db	0			; 0 - creating password, 1 - entering password
len		dw	5
pos		dw	0
password	db	'     '
try		db	'     '

seed		dw	1244
firstly		db	1

data:
